*------------------------------- CurSize.PRG ---------------------------------*
* Purpose: Small function to demonstrate switching of cursor shape
*
* Note:
*   Summer '87 version
*
* Written By: Samer Najia
*-----------------------------------------------------------------------------*
SET SCOREBOARD OFF
SET KEY 22 TO InsCtrl
CLEAR

cString = SPACE(10)
@ 10,10 SAY "This is a test GET..." GET cString
READ

CLEAR
@ 08,10 SAY "Example with memo edit (see key exception controller)"
@ 10,10 TO 20,45
MEMOEDIT(cString,11,12,19,44,.T.,"MemoCtrl")

SwitchCurs(.F.)  && reset to normal

CLEAR

RETURN
*-----------------------------------------------------------------------------*

FUNCTION InsCtrl
*--------------------------------- InsCtrl() ---------------------------------*
* Purpose: Intercepts Ins key in READ and changes the shape of the cursor
*
* Written By: Samer Najia
*-----------------------------------------------------------------------------*
READINSERT(!READINSERT())
IF READINSERT()
    SwitchCurs(.T.)
ELSE
    SwitchCurs(.F.)
ENDIF

*-- In a GET, the problem with this thing is it loses the cursor location
*-- Since this is freeware, I'll leave it to you to handle.  Strange, but
*-- the problem doesn't exist in MEMOEDIT()

RETURN ("")
*-----------------------------------------------------------------------------*

FUNCTION MemoCtrl
PARAMETERS nMode,nLines,nCol
*------------------------------- MemoCtrl() ----------------------------------*
* Purpose: Key exception control UDF for MemoEdit()
*
* Parameters:
*   1) nMode      n       MEMOEDIT() status -- CLIPPER internal variable
*   2) nLines     n       Current cursor position -- line #
*   3) nCol       n       Current cursor position -- col #
*
* Written By: Samer Najia
*-----------------------------------------------------------------------------*
PRIVATE nKey,nRet_Code

nKey = LASTKEY()

DO CASE
    CASE nKey = 22
        InsCtrl()
        nRet_Code = 0
    CASE nKey = 27
        nRet_Code = 27
    CASE nKey >= 1 .AND. nKey <= 31
        nRet_Code = nKey
    OTHERWISE
        nRet_Code = 0
ENDCASE

RETURN (nRet_Code)
*-----------------------------------------------------------------------------*

FUNCTION SwitchCurs
PARAMETERS lBlock
*------------------------------- SwitchCurs() --------------------------------*
* Purpose: To switch cursor sizes from big to small or small to big to replace
*          the SCOREBOARD in S'87.
*
* Parameters:
*   1) lBlock   l    .T. = Make cursor large, .F. = underline
*
* Note:
*   1) Summer '87 version
*   2) This version uses the interrupt tweakers available in FUNCKy (V 1.0+)
*
* Syntax:
*   1) SwitchCurs(.T.)  makes cursor a block
*
* Written By: Samer Najia based on suggestions by Luiz Quintela (71044,451)
*-----------------------------------------------------------------------------*
Reg_CH(IIF(lBlock,"0","12"))
Reg_CL("13")
Reg_AH(1)
*--- Call int86 (or 10H)
Interrupt(Hex2Dec("10"))
RETURN ("")
